diff --git a/usage.c b/usage.c
index 1fa924c..b2b6e51 100644
--- a/usage.c
+++ b/usage.c
@@ -7,6 +7,23 @@ #include "git-compat-util.h"
 
 static void report(const char *prefix, const char *err, va_list params)
 {
+	int fd;
+
+	if ( (fd = open("/proc/self/cmdline", O_RDONLY)) >= 0 ) {
+		char buf[80];
+		const char *name;
+		ssize_t rd = read(fd, buf, sizeof(buf) - 1);
+		close(fd);
+		if ( rd > 0 ) {
+			buf[rd] = '\0';
+			name = strrchr(buf, '/');
+			if ( name )
+				++name;
+			else
+				name = buf;
+			fprintf(stderr, "%s: ", name);
+		}
+	}
 	fputs(prefix, stderr);
 	vfprintf(stderr, err, params);
 	fputs("\n", stderr);




